function test_params()

fid = fopen('eurusd-h1-DST_US.txt');
out = textscan(fid,'%s%f%f%f%f','delimiter',',');
fclose(fid);

T = [out{2} out{3} out{4} out{5}];
L = size(T,1);

% try adding some random noise
% T = T + rand(L,4)/10000;

dn = datenum(out{1});
dv = datevec(dn);

A = 9;
B = 110;
C = 4;
D = 8;

I = find(dv(C+1:end,4)==A) + C;

returns = (T(2:L,1) - T(1:L-1,1)) ./ T(1:L-1,1);

est_dv = zeros(length(I),6);
est_mle = zeros(length(I),1);
est_mse = zeros(length(I),1);
for i = B+1:length(I)
    % make prediction at time I(i)
    t1 = ones(B,1+C);
    for j = 1:B
        k = I(i-B-1+j); % k = I(i-B), I(i-B+1),..., I(i-1)
        t1(j,2:1+C) = returns(k-C:k-1)'; % C most recent returns
    end
    mle = zeros(B,1);
    mse = zeros(B,1);
    for j = 1:B
        k = I(i-B-1+j); % k = I(i-B), I(i-B+1),..., I(i-1)
        op = T(k,1);
        hi = max(T(k:k+D-1,2));
        lo = min(T(k:k+D-1,3));
        mle(j) = (hi - op) / op;
        mse(j) = (op - lo) / op;
    end
    coeff_mle = lsq(t1, mle);
    coeff_mse = lsq(t1, mse);
    tmp = ones(1,1+C);
    k = I(i);
    tmp(1,2:1+C) = returns(k-C:k-1)';
    est_dv(i,:) = dv(I(i),:);
    est_mle(i) = tmp * coeff_mle;
    est_mse(i) = tmp * coeff_mse;
end
tmp = [est_dv est_mle est_mse];

for i = 111:length(I)
    fprintf([datestr(tmp(i,1:6), 'dd/mm/yy HH:MM') ',%f,%f\n'], tmp(i,7), tmp(i,8));
end

end

function coeff = lsq(X, y)
% X: n by m
% y: n by 1
% coeff: n by 1
% Estimate the best fit for y=Xb+e
coeff=(X'*X)\X'*y;
end

